###################################################
### chunk number 1: preliminaries
###################################################
#line 25 "/tmp/RtmpGxHJ2p/R.INSTALL79307622/Matrix/inst/doc/Comparisons.Rnw"
options(width=75)


###################################################
### chunk number 2: modelMatrix
###################################################
#line 56 "/tmp/RtmpGxHJ2p/R.INSTALL79307622/Matrix/inst/doc/Comparisons.Rnw"
data(Formaldehyde)
str(Formaldehyde)
(m <- cbind(1, Formaldehyde$carb))
(yo <- Formaldehyde$optden)


###################################################
### chunk number 3: naiveCalc
###################################################
#line 66 "/tmp/RtmpGxHJ2p/R.INSTALL79307622/Matrix/inst/doc/Comparisons.Rnw"
solve(t(m) %*% m) %*% t(m) %*% yo


###################################################
### chunk number 4: timedNaive
###################################################
#line 74 "/tmp/RtmpGxHJ2p/R.INSTALL79307622/Matrix/inst/doc/Comparisons.Rnw"
system.time(solve(t(m) %*% m) %*% t(m) %*% yo)


###################################################
### chunk number 5: catNaive
###################################################
#line 79 "/tmp/RtmpGxHJ2p/R.INSTALL79307622/Matrix/inst/doc/Comparisons.Rnw"
dput(c(solve(t(m) %*% m) %*% t(m) %*% yo))
dput(unname(lm.fit(m, yo)$coefficients))


###################################################
### chunk number 6: KoenNg
###################################################
#line 91 "/tmp/RtmpGxHJ2p/R.INSTALL79307622/Matrix/inst/doc/Comparisons.Rnw"
library(Matrix)
data(KNex, package = "Matrix")
 y <- KNex$y
mm <- as(KNex$mm, "matrix") # full traditional matrix
dim(mm)
system.time(naive.sol <- solve(t(mm) %*% mm) %*% t(mm) %*% y)


###################################################
### chunk number 7: crossKoenNg
###################################################
#line 119 "/tmp/RtmpGxHJ2p/R.INSTALL79307622/Matrix/inst/doc/Comparisons.Rnw"
system.time(cpod.sol <- solve(crossprod(mm), crossprod(mm,y)))
all.equal(naive.sol, cpod.sol)


###################################################
### chunk number 8: xpxKoenNg
###################################################
#line 129 "/tmp/RtmpGxHJ2p/R.INSTALL79307622/Matrix/inst/doc/Comparisons.Rnw"
system.time(t(mm) %*% mm)


###################################################
### chunk number 9: fullMatrix_crossprod
###################################################
#line 142 "/tmp/RtmpGxHJ2p/R.INSTALL79307622/Matrix/inst/doc/Comparisons.Rnw"
fm <- mm
set.seed(11)
fm[] <- rnorm(length(fm))
system.time(c1 <- t(fm) %*% fm)
system.time(c2 <- crossprod(fm))
stopifnot(all.equal(c1, c2, tol = 1e-12))


###################################################
### chunk number 10: naiveChol
###################################################
#line 163 "/tmp/RtmpGxHJ2p/R.INSTALL79307622/Matrix/inst/doc/Comparisons.Rnw"
system.time(ch <- chol(crossprod(mm)))
system.time(chol.sol <-
            backsolve(ch, forwardsolve(ch, crossprod(mm, y),
                                       upper = TRUE, trans = TRUE)))
stopifnot(all.equal(chol.sol, naive.sol))


###################################################
### chunk number 11: MatrixKoenNg
###################################################
#line 178 "/tmp/RtmpGxHJ2p/R.INSTALL79307622/Matrix/inst/doc/Comparisons.Rnw"
mm <- as(KNex$mm, "dgeMatrix")
class(crossprod(mm))
system.time(Mat.sol <- solve(crossprod(mm), crossprod(mm, y)))
stopifnot(all.equal(naive.sol, unname(as(Mat.sol,"matrix"))))


###################################################
### chunk number 12: saveFactor
###################################################
#line 188 "/tmp/RtmpGxHJ2p/R.INSTALL79307622/Matrix/inst/doc/Comparisons.Rnw"
xpx <- crossprod(mm)
xpy <- crossprod(mm, y)
system.time(solve(xpx, xpy))
system.time(solve(xpx, xpy)) # reusing factorization


###################################################
### chunk number 13: SparseKoenNg
###################################################
#line 199 "/tmp/RtmpGxHJ2p/R.INSTALL79307622/Matrix/inst/doc/Comparisons.Rnw"
mm <- KNex$mm
class(mm)
system.time(sparse.sol <- solve(crossprod(mm), crossprod(mm, y)))
stopifnot(all.equal(naive.sol, unname(as(sparse.sol, "matrix"))))


###################################################
### chunk number 14: SparseSaveFactor
###################################################
#line 211 "/tmp/RtmpGxHJ2p/R.INSTALL79307622/Matrix/inst/doc/Comparisons.Rnw"
xpx <- crossprod(mm)
xpy <- crossprod(mm, y)
system.time(solve(xpx, xpy))
system.time(solve(xpx, xpy))


###################################################
### chunk number 15: sessionInfo
###################################################
#line 220 "/tmp/RtmpGxHJ2p/R.INSTALL79307622/Matrix/inst/doc/Comparisons.Rnw"
toLatex(sessionInfo())


###################################################
### chunk number 16: from_pkg_sfsmisc
###################################################
#line 224 "/tmp/RtmpGxHJ2p/R.INSTALL79307622/Matrix/inst/doc/Comparisons.Rnw"

if(identical(1L, grep("linux", R.version[["os"]]))) { ##----- Linux - only ----

Sys.procinfo <- function(procfile)
{
  l2 <- strsplit(readLines(procfile),"[ \t]*:[ \t]*")
  r <- sapply(l2[sapply(l2, length) == 2],
              function(c2)structure(c2[2], names= c2[1]))
  attr(r,"Name") <- procfile
  class(r) <- "simple.list"
  r
}

Scpu <- Sys.procinfo("/proc/cpuinfo")
Smem <- Sys.procinfo("/proc/meminfo")
} # Linux only


###################################################
### chunk number 17: Sys_proc_fake eval=FALSE
###################################################
## #line 242 "/tmp/RtmpGxHJ2p/R.INSTALL79307622/Matrix/inst/doc/Comparisons.Rnw"
## if(identical(1L, grep("linux", R.version[["os"]]))) { ## Linux - only ---
##  Scpu <- sfsmisc::Sys.procinfo("/proc/cpuinfo")
##  Smem <- sfsmisc::Sys.procinfo("/proc/meminfo")
##  print(Scpu[c("model name", "cpu MHz", "cache size", "bogomips")])
##  print(Smem[c("MemTotal", "SwapTotal")])
## }


###################################################
### chunk number 18: Sys_proc_out
###################################################
#line 250 "/tmp/RtmpGxHJ2p/R.INSTALL79307622/Matrix/inst/doc/Comparisons.Rnw"
if(identical(1L, grep("linux", R.version[["os"]]))) { ## Linux - only ---
 print(Scpu[c("model name", "cpu MHz", "cache size", "bogomips")])
 print(Smem[c("MemTotal", "SwapTotal")])
}


